// This file is generated by kconfig_compiler_kf5 from rulesetbase.kcfg.
// All changes you do to this file will be lost.
#ifndef KILLBOTS_RULESETBASE_H
#define KILLBOTS_RULESETBASE_H

#include <qglobal.h>
#include <kconfigskeleton.h>
#include <QCoreApplication>
#include <QDebug>

namespace Killbots {

class RulesetBase : public KConfigSkeleton
{
  public:
    enum JunkheapsThatCanBePushed { None, One, Many };

    RulesetBase( const QString &cfgfilename = QString() );
    ~RulesetBase();


    /**
      Get Name
    */
    QString name() const
    {
      return mName;
    }


    /**
      Get Author
    */
    QString author() const
    {
      return mAuthor;
    }


    /**
      Get AuthorContact
    */
    QString authorContact() const
    {
      return mAuthorContact;
    }


    /**
      Get Description
    */
    QString description() const
    {
      return mDescription;
    }


    /**
      Get Number of rows in game grid
    */
    int rows() const
    {
      return mRows;
    }


    /**
      Get Number of columns in game grid
    */
    int columns() const
    {
      return mColumns;
    }


    /**
      Get Number of regular enemies in first round
    */
    double enemiesAtGameStart() const
    {
      return mEnemiesAtGameStart;
    }


    /**
      Get Number of regular enemies added in each new round
    */
    double enemiesAddedEachRound() const
    {
      return mEnemiesAddedEachRound;
    }


    /**
      Get Number of fast enemies in first round
    */
    double fastEnemiesAtGameStart() const
    {
      return mFastEnemiesAtGameStart;
    }


    /**
      Get Number of fast enemies added in each new round
    */
    double fastEnemiesAddedEachRound() const
    {
      return mFastEnemiesAddedEachRound;
    }


    /**
      Get Fast enemies will skip their extra turn to avoid collisions with other robots
    */
    bool fastEnemiesArePatient() const
    {
      return mFastEnemiesArePatient;
    }


    /**
      Get Player can accumulate energy
    */
    bool energyEnabled() const
    {
      return mEnergyEnabled;
    }


    /**
      Get Energy at start of first round
    */
    int energyAtGameStart() const
    {
      return mEnergyAtGameStart;
    }


    /**
      Get Energy awarded for completing a round
    */
    int energyAddedEachRound() const
    {
      return mEnergyAddedEachRound;
    }


    /**
      Get Maximum energy cap in first round
    */
    double maxEnergyAtGameStart() const
    {
      return mMaxEnergyAtGameStart;
    }


    /**
      Get Increase in maximum energy cap for each new round
    */
    double maxEnergyAddedEachRound() const
    {
      return mMaxEnergyAddedEachRound;
    }


    /**
      Get Player can perform safe teleports
    */
    bool safeTeleportEnabled() const
    {
      return mSafeTeleportEnabled;
    }


    /**
      Get The cost of performing a safe teleport
    */
    int costOfSafeTeleport() const
    {
      return mCostOfSafeTeleport;
    }


    /**
      Get Player can use vaporizer
    */
    bool vaporizerEnabled() const
    {
      return mVaporizerEnabled;
    }


    /**
      Get Cost of using vaporizer
    */
    int costOfVaporizer() const
    {
      return mCostOfVaporizer;
    }


    /**
      Get Number of junkheaps that can be pushed at once
    */
    JunkheapsThatCanBePushed pushableJunkheaps() const
    {
      return static_cast<JunkheapsThatCanBePushed>(mPushableJunkheaps);
    }


    /**
      Get Player can destroy enemies with a pushed junkheap
    */
    bool squaskKillsEnabled() const
    {
      return mSquaskKillsEnabled;
    }


    /**
      Get Junkheaps placed on grid at start of first round
    */
    double junkheapsAtGameStart() const
    {
      return mJunkheapsAtGameStart;
    }


    /**
      Get Junkheaps added to the grid for each new round
    */
    double junkheapsAddedEachRound() const
    {
      return mJunkheapsAddedEachRound;
    }


    /**
      Get Points awarded for each regular enemy destroyed
    */
    int pointsPerEnemyKilled() const
    {
      return mPointsPerEnemyKilled;
    }


    /**
      Get Points awarded for each fast enemy destroyed
    */
    int pointsPerFastEnemyKilled() const
    {
      return mPointsPerFastEnemyKilled;
    }


    /**
      Get Points awarded for each enemy destroyed while waiting out the round
    */
    int waitKillPointBonus() const
    {
      return mWaitKillPointBonus;
    }


    /**
      Get Energy awarded for each enemy destroyed while waiting out the round
    */
    int waitKillEnergyBonus() const
    {
      return mWaitKillEnergyBonus;
    }


    /**
      Get Points awarded for each enemy destroyed with a pushed junkheap
    */
    int squashKillPointBonus() const
    {
      return mSquashKillPointBonus;
    }


    /**
      Get Energy awarded for each enemy destroyed with a pushed junkheap
    */
    int squashKillEnergyBonus() const
    {
      return mSquashKillEnergyBonus;
    }


    /**
      Get Points awarded for each energy awarded above maximum energy cap
    */
    int pointsPerEnergyAboveMax() const
    {
      return mPointsPerEnergyAboveMax;
    }

  protected:

    // KillbotsRuleset
    QString mName;
    QString mAuthor;
    QString mAuthorContact;
    QString mDescription;
    int mRows;
    int mColumns;
    double mEnemiesAtGameStart;
    double mEnemiesAddedEachRound;
    double mFastEnemiesAtGameStart;
    double mFastEnemiesAddedEachRound;
    bool mFastEnemiesArePatient;
    bool mEnergyEnabled;
    int mEnergyAtGameStart;
    int mEnergyAddedEachRound;
    double mMaxEnergyAtGameStart;
    double mMaxEnergyAddedEachRound;
    bool mSafeTeleportEnabled;
    int mCostOfSafeTeleport;
    bool mVaporizerEnabled;
    int mCostOfVaporizer;
    int mPushableJunkheaps;
    bool mSquaskKillsEnabled;
    double mJunkheapsAtGameStart;
    double mJunkheapsAddedEachRound;
    int mPointsPerEnemyKilled;
    int mPointsPerFastEnemyKilled;
    int mWaitKillPointBonus;
    int mWaitKillEnergyBonus;
    int mSquashKillPointBonus;
    int mSquashKillEnergyBonus;
    int mPointsPerEnergyAboveMax;

  private:
};

}

#endif

